config/routes.rb
Rails.application.routes.draw do

  resources :credit_sources
  resources :crop_types
  mount_devise_token_auth_for 'User', at: 'auth'
  get 'report/index'
  get 'report/topography'
  get 'report/smu'
  get 'report/category'
  get 'report/report_list'
  get 'report/farmer_count'
  get 'report/cultivation_cost'
  get 'report/live_stock'
  get 'report/main_yield'
  get 'report/marketing'
  get 'report/comments'
  get 'report/soil_status'
  get 'report/additional_invst_src'
  
  get 'farmers/count'
  get 'users/register'
  get 'users/signin'
  get 'users/template'
  get 'users/index'
  get 'users/actions'
  get 'users/user_roles_template'
  get 'users/user_roles'
  post 'users/create_user_role'
  post 'users/delete_user_role'
 

  post 'offline/sync'

  get "/application.appcache", to: "offline#manifest", :format => :appcache

  get 'roles/ractions'
  get 'roles/role_ractions_template'
  get 'roles/role_ractions'
  get 'roles/role'
  post 'roles/create_role_raction'
  post 'roles/delete_role_raction'

    resources :ractions
  resources :actions
  resources :roles

    root 'socio_demographic_infos#new'
  resources :basic_need_details
  resources :migration_consequences
  resources :labour_migration_details
  resources :migration_negative_consequences
  resources :migration_positive_consequences
  resources :migration_purposes
  resources :fertilizers
  resources :pc_wage_rates
  resources :pc_yield_prices
  resources :intercrop_lists
  resources :crop_lists
  resources :pc_other_expenses
  resources :pc_operation_details
  resources :survey_numbers
  resources :forestry_plants
  resources :horticulture_plants
  resources :livestock_names
  resources :credit_avail_purposes
  resources :suggestion_paramaters
  resources :food_materials
  resources :constraints
  resources :conversation_structures
  resources :particulars
  resources :purposes
  resources :income_sources
  resources :intercrops
  resources :crops
  resources :grampanchayats
  resources :hoblis
  resources :micro_water_sheds
  resources :sub_water_sheds
  resources :taluks
  resources :districts
  resources :castes
  resources :smus
  resources :topographies
  resources :farmers
  resources :horticulture_forestry_plants
  resources :production_costs
  resources :fertilizer_details
  resources :ppc_details
  resources :forestry_cultivations
  resources :forestry_species
  resources :cultivate_horticultures
  resources :plant_counts
  resources :subsidiary_costs
  resources :subsidiary_enterprises
  resources :private_credits
  resources :institutional_credits
  resources :borrowing_statuses
  resources :basic_needs
  resources :labour_availabilities
  resources :watershed_comments
  resources :improvement_suggestions
  resources :household_food_materials
  resources :farming_constraints
  resources :conversation_practices
  resources :watershed_awarenesses
  resources :marketings
  resources :additional_investment_capacities
  resources :family_annual_incomes
  resources :fodder_availabilities
  resources :cropping_intensities
  resources :cropping_paterns
  resources :irrigations
  resources :surveys

  resources :durable_assets
  resources :machines
  resources :livestocks
  resources :livestock_types
  resources :machine_types
  resources :asset_types
  resources :house_types
  resources :houses
  resources :housetypes
  resources :local_organisations
  resources :genders
  resources :occupations
  resources :scaffolds
  resources :educations
  resources :socio_demographic_infos
  resources :villages
  match "*path", to: "welcome#catch_404", via: :all

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/cropping_patern.rb
class CroppingPatern < ApplicationRecord
  belongs_to :crop
  belongs_to :intercrop
  belongs_to :survey_number
end

app/controllers/cropping_paterns_controller.rb
class CroppingPaternsController < ApplicationController
  before_action :set_cropping_patern, only: [:show, :edit, :update, :destroy]

  # GET /cropping_paterns
  # GET /cropping_paterns.json
  def index
    @cropping_paterns = params[:farmer_id].present? ? CroppingPatern.where(farmer_id: params[:farmer_id]) : CroppingPatern.all
    render layout: false
  end

  # GET /cropping_paterns/1
  # GET /cropping_paterns/1.json
  def show
  end

  # GET /cropping_paterns/new
  def new
    @cropping_patern = CroppingPatern.new
  end

  # GET /cropping_paterns/1/edit
  def edit
  end

  # POST /cropping_paterns
  # POST /cropping_paterns.json
  def create
    @cropping_patern = CroppingPatern.new(cropping_patern_params)

    respond_to do |format|
      if @cropping_patern.save
        format.html { redirect_to @cropping_patern, notice: 'Cropping patern was successfully created.' }
        format.json { render :show, status: :created, location: @cropping_patern }
      else
        format.html { render :new }
        format.json { render json: @cropping_patern.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /cropping_paterns/1
  # PATCH/PUT /cropping_paterns/1.json
  def update
    respond_to do |format|
      if @cropping_patern.update(cropping_patern_params)
        format.html { redirect_to @cropping_patern, notice: 'Cropping patern was successfully updated.' }
        format.json { render :show, status: :ok, location: @cropping_patern }
      else
        format.html { render :edit }
        format.json { render json: @cropping_patern.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /cropping_paterns/1
  # DELETE /cropping_paterns/1.json
  def destroy
    @cropping_patern.destroy
    respond_to do |format|
      format.html { redirect_to cropping_paterns_url, notice: 'Cropping patern was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_cropping_patern
      @cropping_patern = CroppingPatern.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def cropping_patern_params
      params.require(:cropping_patern).permit(:farmer_id, :survey_number_id, :total_land, :crop_id, :intercrop_id, :season)
    end
end

app/helpers/cropping_paterns_helper.rb
module CroppingPaternsHelper
end

app/views/cropping_paterns/_form.html.haml
= form_for @cropping_patern do |f|
  - if @cropping_patern.errors.any?
    #error_explanation
      %h2= "#{pluralize(@cropping_patern.errors.count, "error")} prohibited this cropping_patern from being saved:"
      %ul
        - @cropping_patern.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :survey_number
    = f.text_field :survey_number
  .field
    = f.label :total_land
    = f.text_field :total_land
  .field
    = f.label :crop_id
    = f.number_field :crop_id
  .field
    = f.label :intercrop_id
    = f.number_field :intercrop_id
  .field
    = f.label :season
    = f.text_field :season
  .actions
    = f.submit 'Save'

app/views/cropping_paterns/edit.html.haml
%h1 Editing cropping_patern

= render 'form'

= link_to 'Show', @cropping_patern
\|
= link_to 'Back', cropping_paterns_path

app/views/cropping_paterns/index.html.haml
.panel.panel-default{"ng-controller" => "CroppingPaternCtrl"}
  .panel-heading{ :style => "border-bottom:1px solid #f0f0f0"}
    %h4.text-primary Cropping Pattern
  .panel-body
    .table-responsive
      %table.table
        %thead
          %tr
            %th Survey Number
            %th Area in Acre(s)
            %th Crops
            %th Intercrops
            %th Season
      
        %tbody
          %tr{ "ng-repeat" => "croping_patern in data_list "}
            %td {{ croping_patern.survey_number.number }}
            %td {{ croping_patern.total_land}}
            %td {{ croping_patern.crop.title }}
            %td {{ croping_patern.intercrop.title }}
            %td {{ croping_patern.season }}
            %td
              %a{ "ng-click" => "edit(croping_patern.id);" } 
                %i.fa.fa-pencil{"aria-hidden"=>"true", :style=>"color:#D0D0D0"}
            %td
              %a{ "ng-click" => "delete(croping_patern.id, croping_patern.url);" }     
                %i.fa.fa-trash-o.fa-fw{"aria-hidden"=>"true", :style=>"color:#D0D0D0"}
          %tr#form_croping_patern
            %td
              %select{"ng-model" => "vm.survey_number", "ng-options" => "survey_number.number for survey_number in survey_numbers track by survey_number.id", :class => "form-control"}
                %option{:value=>'', :selected => 'selected'} Select
            %td
              = number_field :total_land, '', :class => "form-control", "ng-model" => "vm.total_land"
            %td
              %select{"ng-model" => "vm.crop", "ng-options" => "crop.title for crop in crops track by crop.id", :class => "form-control", :placeholder => "Select"}
                %option{:value=>'', :selected => 'selected'} Select
            %td
              %select{"ng-model" => "vm.intercrop", "ng-options" => "intercrop.title for intercrop in intercrops track by intercrop.id", :class => "form-control", :placeholder => "Select"}
                %option{:value=>'', :selected => 'selected'} Select
            %td
              = select_tag :season, options_for_select(["Kharif","Rabi","Summer"]), :prompt => "Select",:class => "form-control", "ng-model" => "vm.season"
              
  .panel-footer
    %button{:class => "btn btn-primary btn-sm", "ng-show" => "btn_add", "ng-click" => "submit()"} Add  
    %button{:class => "btn btn-primary btn-sm", "ng-show" => "btn_update", "ng-click" => "update()"} Update  
    %button{:class => "btn btn-primary btn-sm", "ng-show" => "btn_cancel", "ng-click" => "cancel()"} Cancel 
    %button{:class => "btn btn-primary btn-sm pull-right", "ng-click" => "next()"}
      %i.fa.fa-chevron-right{"aria-hidden"=>"true", :style=>"color:#FFF"}
    %button{:class => "btn btn-primary btn-sm pull-right", "ng-click" => "prev()", :style => "margin-right:5px"} 
      %i.fa.fa-chevron-left{"aria-hidden"=>"true", :style=>"color:#FFF"} 

app/views/cropping_paterns/new.html.haml
%h1 New cropping_patern

= render 'form'

= link_to 'Back', cropping_paterns_path

app/views/cropping_paterns/show.html.haml
%p#notice= notice

%p
  %b Survey number:
  = @cropping_patern.survey_number
%p
  %b Total land:
  = @cropping_patern.total_land
%p
  %b Crop:
  = @cropping_patern.crop_id
%p
  %b Intercrop:
  = @cropping_patern.intercrop_id
%p
  %b Season:
  = @cropping_patern.season

= link_to 'Edit', edit_cropping_patern_path(@cropping_patern)
\|
= link_to 'Back', cropping_paterns_path